function url_breaker_execute(doc) {
	var resolver = doc.createNSResolver(doc.documentElement);
	var xpath;
	if(url_breaker_getPrefValue("skz.url_breaker.linkonly")){
		xpath = '/descendant::*[local-name() = "A"]/descendant::text()';
	}else{
		xpath = '/descendant::*[not(contains(" TITLE STYLE SCRIPT TEXTAREA XMP ", concat(" ", local-name(), " ")))]/child::text()';
	}
	var nodes = doc.evaluate(
			xpath,
			doc.documentElement,
			resolver,
			XPathResult.ORDERED_NODE_SNAPSHOT_TYPE,
			null
		);
	var regexp = new RegExp("([!-%'-/:=\\?@\\[-`\\{-~]|&amp;)");
	var regexp2 = null;
	if(url_breaker_getPrefValue("skz.url_breaker.forcebreak")){
		regexp2 = new RegExp("(([!-%'-:=\\?-~]|&amp){"
			+ url_breaker_getPrefValue("skz.url_breaker.forcebreak_length")
			+ "})"
		);
	}
	var range  = doc.createRange();
	var wbr    = doc.createElement('wbr');
	var br    = doc.createElement('br');
	for (var i = 0; i < nodes.snapshotLength; i++)
	{
		var node = nodes.snapshotItem(i);
		var lastIndex = 0;
		range.selectNode(node);
		while(true){
			if(regexp2 && node && (lastIndex = range.toString().search(regexp2)) > -1) {
				range.setStart(node, lastIndex+RegExp.$1.length);
				range.insertNode(br.cloneNode(true));
				node = node.nextSibling.nextSibling;
				range.selectNode(node);
			}else if(node && (lastIndex = range.toString().search(regexp)) > -1) {
				range.setStart(node, lastIndex+RegExp.$1.length);
				range.insertNode(wbr.cloneNode(true));
				node = node.nextSibling.nextSibling;
				range.selectNode(node);
			}else{
				break;
			}
		}
	}
	range.detach();
}


function getPrefBranch(){
	if(!url_breaker_pref_branch_cache){
		url_breaker_pref_branch_cache = Components.classes["@mozilla.org/preferences-service;1"]
		                           .getService(Components.interfaces.nsIPrefBranch);
	}
	return url_breaker_pref_branch_cache;
}
var url_breaker_pref_branch_cache = null;

function url_breaker_getPrefValue(aPrefString){
	var defaultValue = url_breaker_getDefaultValue(aPrefString);
	var result = defaultValue;

	try{
		switch(typeof(defaultValue)){
			case "boolean":
				result = getPrefBranch().getBoolPref(aPrefString);
				break;
			case "number":
				result = getPrefBranch().getIntPref(aPrefString);
				break;
			case "string":
				result = getPrefBranch().getComplexValue(aPrefString,
					Components.interfaces.nsISupportsString).data;
				break;
		}
	}catch(ex){
		result = defaultValue;
	}		
	return result;
}

function url_breaker_getDefaultValue(aPrefString){
	switch(aPrefString){
		case "skz.url_breaker.linkonly":
			return false;
		case "skz.url_breaker.forcebreak":
			return false;
		case "skz.url_breaker.forcebreak_length":
			return 80;
	}
	return 0;
}

function url_breaker_setPrefValue(aPrefString, aPrefValue) {
	var defaultValue = url_breaker_getDefaultValue(aPrefString);
  var prefBranch = getPrefBranch();

	switch(typeof(defaultValue)){
		case "boolean":
			prefBranch.setBoolPref(aPrefString, aPrefValue);
			break;
		case "number":
			prefBranch.setIntPref(aPrefString, aPrefValue);
			break;
		case "string":
			var supportsString = Components.classes["@mozilla.org/supports-string;1"]
				.createInstance(Components.interfaces.nsISupportsString);
			supportsString.data = aPrefValue;
			prefBranch.setComplexValue(aPrefString,
				Components.interfaces.nsISupportsString, supportsString);
			break;
	}
}
